//CoinsArrondis_403f.js
// 14.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Munir des blocs avec des coins arrondis (optionnel: bomber).

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// mmoriser le document actif
var curDoc = app.documents[0];

// mmoriser la version du programme
var appVers = app.version[0];

// mmoriser et tester la slection
var curSel = app.selection;
var nFrames = curSel.length;
if (nFrames == 0) {
	alert ("Il n'y a pas de slection.", "Stop");
	exit();
}

// vrifier (avant de montrer le dialogue) s'il y a parmi les objets 
// slectionns au moins un qui est en ordre. Compter les objets, ainsi le 
// dialogue sera montr de suite (avec un objet) ou  la fin (deux et plus)
var cCtr = fCtr = pCtr = uCtr = 0;
for (var i=0; i<nFrames; i++) {
	var curItem = curSel[i];
	testGroupItems(curItem);
}

// la fonction qui dtaille des groupes ventuels
function testGroupItems(curFrame) {
	var curType = curFrame.constructor.name;
	if (curType == "Rectangle" || curType == "TextFrame" || curType == "Oval" || curType == "Polygon") {
		fCtr++;
	}
	else if (curType == "Group") {
		var allFrames = curFrame.allPageItems;
		for (var i=0; i< allFrames.length; i++) {
			var curFrame = allFrames[i];
			var curType = curFrame.constructor.name;
			if (curType != "Group") {
				testGroupItems(curFrame);
			}
		}
	}
}
if (fCtr == 0) {
	alert ("Slectionner un bloc rectangulaire et relancer le script.", "Attention");
	exit();
}

// mmoriser les units de mesure
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
// si celle de la verticale diffre, la rgler comme l'horizontale
if (vM != hM) {
	curDoc.viewPreferences.verticalMeasurementUnits = hM;
}

// la valeur de correction par laquelle les rayons sont rapetisss
// avant de bomber lgrement les droites
var corrVal = 0.92;

// aller chercher l'unit de mesure actuelle en chane de texte
var curUnit = unitsEnumToString(hM);

// passer l'unit  "millimtres" si inconnu
if (curUnit == "inconnu") {
	curUnit = "en millimtres";
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// appeler la fonction pour lire les prfrences enregistrs
var effectsDef = getPrefs();
// extraire les quatre valeurs des rayons
if (effectsDef != "") {
	var defVal = effectsDef.split("\n");
	var topL = defVal[0]*1;
	var topR = defVal[1]*1;
	var botL = defVal[2]*1;
	var botR = defVal[3]*1;
	var camber = defVal[4];
	if (camber == "true") {
		camb = true;
	}
	else {
		camb = false;
	}
}
else {
	var topL = 5;
	var topR = 5;
	var botL = 5;
	var botR = 5;
	var camb = false;
}

// montrer le dialogue
var effectsDef = askUser();

// appeler la fonction qui crit le rsultat dans un fichier
writeResult(effectsDef);

// une boucle  travers la slection
for (var i=0; i<nFrames; i++) {
	curItem = curSel[i];
	handleGroupItems(curItem);
}

// la fonction qui s'occupe des groupes
function handleGroupItems(curFrame) {
	curType = curFrame.constructor.name;
	if (curType == "Rectangle" || curType == "TextFrame" || curType == "Oval" || curType == "Polygon") {
		// desactiver une option de coins ventuelle
		if (appVers > 6) {
			curFrame.topLeftCornerOption     = CornerOptions.NONE;
			curFrame.topLeftCornerRadius     = "12pt";
			curFrame.bottomLeftCornerOption  = CornerOptions.NONE;
			curFrame.bottomLeftCornerRadius  = "12pt";
			curFrame.bottomRightCornerOption = CornerOptions.NONE;
			curFrame.bottomRightCornerRadius = "12pt";
			curFrame.topRightCornerOption    = CornerOptions.NONE;
			curFrame.topRightCornerRadius    = "12pt";
		}
		else if (appVers < 7 && appVers > 4) {
			if (curFrame.cornerOption != 1852796517) {
				curFrame.cornerOption = 1852796517;
			}
		}
		else if (appVers < 5) {
			if (curFrame.cornerEffect != 1852796517) {
				curFrame.cornerEffect = 1852796517;
			}
		}
		// le chemin du bloc courant
		curPath = curFrame.paths.item(0);
		if (curPath.pathType == 1668051812) {
			makeCorners(curFrame);
		}
		else {
			if (fCtr == 1) {
				alert ("Ce n'est pas un chemin ferm.", "Stop");
				resetAsBefore();
				exit();
			}
			else {
				cCtr++;
			}
		}
	}
	else if (curType == "Group") {
		var allFrames = curFrame.allPageItems;
		for (var k=0; k<allFrames.length; k++) {
			curFrame = allFrames[k];
			curType = curFrame.constructor.name;
			if (curType != "Group") {
				handleGroupItems(curFrame);
			}
		}
	}
}

// appeler la fonction pour rtablir les modifications
resetAsBefore();

// communiquer les problmes ventuels
if (pCtr == 1) {
	alert ("Les valeurs sont trop grands pour l'un des blocs.", "Un problme");
}
else if (pCtr > 1) {
	alert ("Les valeurs sont trop grands pour " + pCtr + " blocs.", "Des problmes");
}
if (cCtr == 1) {
	alert ("Le chemin d'un bloc n'est pas ferm.", "Un problme");
}
else if (cCtr > 1) {
	alert ("" + cCtr + " blocs n'ont pas de chemins ferms.", "Des problmes");
}
if (uCtr == 1) {
	alert ("Un problme inconnu. Les coins n'ont pas pu tre arrondis.", "Cela ne marche pas");
}
else if (uCtr > 1) {
	alert ("" + uCtr + " problmes inconnus. Les coins n'ont pas pu tre arrondis.", "Cela ne marche pas");
}


// -----------------------------------------------------------------------
// les fonctions
// -----------------------------------------------------------------------

// convertir l'unit de mesure actuelle en chane de texte
function unitsEnumToString(hM) {
	switch(hM) {
		case 2054188905 :
			return "en points";
		case 2054187363 :
			return "en picas";
		case 2053729891 :
			return "en pouces";
		case 2053729892 :
			return "en pouces dcimales";
		case 2053991795 :
			return "en millimtres";
		case 2053336435 :
			return "en centimtres";
		case 2053335395 :
			return "en cicros";
		case 2051106676 :
			return "en agates";
		case 1131639917 :
			return "dfini par l'utilisateur";
		default :
			return "inconnu";
	}
}

// la fonction qui prpare les informations
function getPrefs() {
	var effectsDef = "";
	// lire le fichier contenant les valeurs mmorises
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/corner3.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			effectsDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return effectsDef;
}

// demander l'utilisateur d'entrer les valeurs
function askUser() {
	// effacer des dialogues qui sont ventuellement rests dans la mmoire
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var aDialog = app.dialogs.add({name:"CoinsArrondis", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Les rayons (" + curUnit + ")"});
				staticTexts.add({staticLabel:" "});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							var topLeft = realEditboxes.add({editValue:topL, minimumValue:0, maximumValue:9999, minWidth:48});
							staticTexts.add({staticLabel:" ", minWidth:32});
							var topRght = realEditboxes.add({editValue:topR, minimumValue:0, maximumValue:9999, minWidth:48});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							var botLeft = realEditboxes.add({editValue:botL, minimumValue:0, maximumValue:9999, minWidth:48});
							staticTexts.add({staticLabel:" ", minWidth:32});
							var botRght = realEditboxes.add({editValue:botR, minimumValue:0, maximumValue:9999, minWidth:48});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var camberStraight = checkboxControls.add({staticLabel:"bomber les droites trs lgrement", checkedState:camb});
				}
			}
		}
	}
	
	// montrer le dialogue
	if (aDialog.show() == true) {
		// le coin en haut  gauche
		topL = topLeft.editValue;
		// le coin en haut  droite
		topR = topRght.editValue;
		// le coin en bas  gauche
		botL = botLeft.editValue;
		// le coin en bas  droite
		botR = botRght.editValue;
		// les boutons radio (invisibles)
		topLBtn = topRBtn = 0;
		botLBtn = botRBtn = 2;
		// la case  cocher "bomber"
		var camberStr = camberStraight.checkedState;
		camber = camberStr;
		// effacer le dialogue de la mmoire
		aDialog.destroy();
		// prparer le rsultat pour le mmoriser
		var effectsDef = topL + "\n" + topR + "\n" + botL + "\n" + botR + "\n" + camber;
	}
	else {
		aDialog.destroy();
		resetAsBefore();
		exit();
	}
	return effectsDef;
}

// crire le rsultat dans un fichier
function writeResult(effectsDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/corner3.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(effectsDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// ---/---/---/---/---/---/---/---/---/---/---/---/
// la fonction principale
function makeCorners(curFrame) {
	// vrifier s'il y a au moins une valeur plus grande que zro
	if ((topL+topR+botL+botR) == 0) {
		if (curPath.pathPoints.length == 4) {
			return;
		}
	}
	
	// annuler un verrouillage ventuel
	unLock = unLockParent = false;
	if (curFrame.locked == true) {
		unLock = true;
		try {
			curFrame.locked = false;
		}
		catch (e) {
			unLockParent = true;
			actType = "Group";
			actFrame = curFrame.parent;
			while (actType == "Group") {
				actType = actFrame.constructor.name;
				if (actType == "Group") {
					topGroup = actFrame;
				}
				try {
					actFrame.locked = false;
				}
				catch (e) {
				}
				actFrame = actFrame.parent;
			}
		}
	}
	
	// mmoriser l'angle de rotation et d'inclinaison et les mettre  zro
	rA = curFrame.rotationAngle;
	sA = curFrame.shearAngle;
	if (sA != 0) {
		curFrame.shearAngle = 0;
	}
	if (rA != 0) {
		curFrame.rotationAngle = 0;
	}
	
	// mmoriser les positions des bords
	gB = curFrame.geometricBounds;
	// mmoriser la hauteur et la largeur du bloc...
	oH = Math.floor((((gB[2]-gB[0])*1000)+0.5))/1000;
	oW = Math.floor((((gB[3]-gB[1])*1000)+0.5))/1000;
	// ... et vrifier
	if (oH < 1) {
		return;
	}
	else if (oW < 1) {
		return;
	}
	
	// comparer la dimension du bloc et les valeurs des rayons
	if ((topL+topR) > oW) {
		if (fCtr == 1) {
			alert ("Le total des rayons \"en haut  gauche\" plus \"en haut  droite\" est trop grand.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((botL+botR) > oW) {
		if (fCtr == 1) {
			alert ("Le total des rayons \"en bas  gauche\" plus \"en bas  droite\" est trop grand.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((topL+botL) > oH) {
		if (fCtr == 1) {
			alert ("Le total des rayons \"en haut  gauche\" plus \"en bas  gauche\" est trop grand.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((topR+botR) > oH) {
		if (fCtr == 1) {
			alert ("Le total des rayons \"en haut  droite\" plus \"en bas  droite\" est trop grand.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	
	// prparer le nouveau chemin
	newPath = new Array ();
	
	// diminuer les rayons trs lgrement s'il faut bomber les droites
	if (camber) {
		if (!(topL+topR) == oW && !(botL+botR) == oW && !(topL+botL) == oH && !(topR+botR) == oH) {
			if (!(topL+topR) == oW && !(botL+botR) == oW) {
				if (!(topL+botL) == oH && !(topR+botR) == oH) {
					topL = topL*corrVal;
					topR = topR*corrVal;
					botR = botR*corrVal;
					botL = botL*corrVal;
				}
				else {
					if ((topL+topR) == oW) {
						botR = botR*corrVal;
						botL = botL*corrVal;
					}
					else if ((botL+botR) == oW) {
						topL = topL*corrVal;
						topR = topR*corrVal;
					}
					else if ((topL+botL) == oH) {
						topR = topR*corrVal;
						botR = botR*corrVal;
					}
					else if ((topR+botR) == oH) {
						topL = topL*corrVal;
						botL = botL*corrVal;
					}
				}
			}
		}
	}
	// les positions des points d'ancrage
	aT1   = gB[1]+topL;
	aT2   = gB[3]-topR;
	aR1   = gB[0]+topR;
	aR2   = gB[2]-botR;
	aB2   = gB[3]-botR;
	aB1   = gB[1]+botL;
	aL2   = gB[2]-botL;
	aL1   = gB[0]+topL;
	aT1b  = [aT1, gB[0]];
	aT2b  = [aT2, gB[0]];
	aR1b  = [gB[3], aR1];
	aR2b  = [gB[3], aR2];
	aB2b  = [aB2, gB[2]];
	aB1b  = [aB1, gB[2]];
	aL2b  = [gB[1], aL2];
	aL1b  = [gB[1], aL1];
	// les dcalages des points directeurs
	T1off = topL * 0.552284743254;
	T2off = topR * 0.552284743254;
	R1off = topR * 0.552284743254;
	R2off = botR * 0.552284743254;
	B2off = botR * 0.552284743254;
	B1off = botL * 0.552284743254;
	L2off = botL * 0.552284743254;
	L1off = topL * 0.552284743254;
	// les valeurs de correction
	if (camber) {
		T1cor = topL/30;
		L1cor = topL/30;
		if (T1cor > L1cor) { TLcor = L1cor; } else { TLcor = T1cor; }
		T2cor = topR/30;
		R1cor = topR/30;
		if (T2cor > R1cor) { TRcor = R1cor; } else { TRcor = R1cor; }
		R2cor = botR/30;
		B2cor = botR/30;
		if (R2cor > B2cor) { BRcor = B2cor; } else { BRcor = R2cor; }
		B1cor = botL/30;
		L2cor = botL/30;
		if (B1cor > L2cor) { BLcor = L2cor; } else { BLcor = B1cor; }
	}
	else {
		TLcor = TRcor = BRcor = BLcor = 0;
	}
	
	// si le rsultat est un carr...
	if ((topL+topR) == oW && (botL+botR) == oW && (topL+botL) == oH && (topR+botR) == oH) {
		roundedBottom();
		roundedRight();
		roundedTop();
		roundedLeft();
	}
	else {
		// "en haut  gauche"  plus "en haut  droite"  = la largeur du bloc
		// "en bas  gauche" plus "en bas  droite" = la largeur du bloc
		if ((topL+topR) == oW && (botL+botR) == oW) {
			// le point d'ancrage en bas  droite /////////////
			anchorRight2();
			// le point d'ancrage en haut  droite /////////////
			anchorRight1();
			// l'arrondi en haut /////////////
			roundedTop();
			// le point d'ancrage en haut  gauche /////////////
			anchorLeft1();
			// le point d'ancrage  gauche en bas /////////////
			anchorLeft2();
			// l'arrondi en bas /////////////
			roundedBottom();
		}
		// "en haut  gauche" plus "en haut  droite" = la largeur du bloc
		else if ((topL+topR) == oW) {
			// le point d'ancrage en bas  droite /////////////
			anchorRight2();
			// le point d'ancrage en haut  droite /////////////
			anchorRight1();
			// l'arrondi en haut /////////////
			roundedTop();
			// le point d'ancrage en haut  gauche /////////////
			anchorLeft1();
			// le coin  gauche en bas /////////////
			cornerBottomLeft();
			// le point d'ancrage en bas  droite /////////////
			anchorBottom2();
		}
		// "en bas  gauche" plus "en bas  droite"= la largeur du bloc
		else if ((botL+botR) == oW) {
			// le point d'ancrage en bas  droite /////////////
			anchorRight2();
			// le coin  droite en haut /////////////
			cornerTopRight();
			// le coin  gauche en haut /////////////
			cornerTopLeft();
			// le point d'ancrage  gauche en bas /////////////
			anchorLeft2();
			// l'arrondi en bas /////////////
			roundedBottom();
		}
		// "en haut  gauche"  plus "en bas  gauche" = la hauteur du bloc
		// "en haut  droite" plus "en bas  droite"= la hauteur du bloc
		else if ((topL+botL) == oH && (topR+botR) == oH) {
			// l'arrondi  droite /////////////
			roundedRight();
			// le point d'ancrage en haut  droite /////////////
			anchorTop2();
			// le point d'ancrage en haut  gauche /////////////
			anchorTop1();
			// l'arrondi  gauche /////////////
			roundedLeft();
			// le point d'ancrage en bas  gauche /////////////
			anchorBottom1();
			// le point d'ancrage en bas  droite /////////////
			anchorBottom2();
		}
		// "en haut  gauche"  plus "en bas  gauche" = la hauteur du bloc
		else if ((topL+botL) == oH) {
			// le point d'ancrage en bas  droite /////////////
			anchorRight2();
			// le coin  droite en haut /////////////
			cornerTopRight();
			// le point d'ancrage en haut  gauche /////////////
			anchorTop1();
			// l'arrondi  gauche /////////////
			roundedLeft();
			// le point d'ancrage en bas  gauche /////////////
			anchorBottom1();
			// le point d'ancrage en bas  droite /////////////
			anchorBottom2();
		}
		// "en haut  droite" plus "en bas  droite" = la hauteur du bloc
		else if ((topR+botR) == oH) {
			// l'arrondi  droite /////////////
			roundedRight();
			// le point d'ancrage en haut  droite /////////////
			anchorTop2();
			// le coin  gauche en haut /////////////
			cornerTopLeft();
			// le coin  gauche en bas /////////////
			cornerBottomLeft();
			// le point d'ancrage en bas  droite /////////////
			anchorBottom2();
		}
		else {
			// le point d'ancrage en bas  droite /////////////
			anchorRight2();
			// le coin  droite en haut /////////////
			cornerTopRight();
			// le coin  gauche en haut /////////////
			cornerTopLeft();
			// le coin  gauche en bas /////////////
			cornerBottomLeft();
			// le point d'ancrage en bas  droite /////////////
			anchorBottom2();
		}
	}
	
	// appliquer le nouveau chemin
	try {
		curPath.entirePath = newPath;
	}
	catch (e) {
		if (fCtr == 1) {
			alert ("Un problme inconnu a empch d'arrondir le coin.", "Cela ne marche pas");
		}
		else {
			uCtr++;
		}
	}
	
	// rtablir la largeur et la hauteur
	curFrame.geometricBounds = gB;
	
	// rtablir les angles de rotation et d'inclinaison (si ncessaire)
	if (rA != 0) {
		curFrame.rotationAngle = rA;
	}
	if (sA != 0) {
		curFrame.shearAngle = sA;
	}
	
	// rtablir le verrouillage
	if (unLockParent == true) {
		try {
			topGroup.locked = true;
		}
		catch (e) {
		}
	}
	else if (unLock == true) {
		try {
			curFrame.locked = true;
		}
		catch (e) {
		}
	}
}


// ---*---*---*---*---*---*---*---*---*---*---*---*
// ----- les fonctions effet ----------------------
// ---*---*---*---*---*---*---*---*---*---*---*---*

// le point d'ancrage en haut  gauche /////////////
function anchorTop1() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber && ((aT2-aT1)>(T1off+T2off))) {
				hT1a = [aT1+T1off, gB[0]-TLcor];
				hT1c = [aT1-T1off, gB[0]+TLcor];
			}
			else {
				hT1a = [aT1, gB[0]];
				hT1c = [aT1-T1off, gB[0]];
			}
			newPath.push([hT1a, aT1b, hT1c]);
		}
		else if (topLBtn == 1) {
			newPath.push(aT1b);
		}
		else if (topLBtn == 2) {
			hT1a = [aT1, gB[0]];
			hT1c = [aT1, gB[0]+T1off];
			newPath.push([hT1a, aT1b, hT1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// le point d'ancrage en haut  droite /////////////
function anchorTop2() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber && ((aT2-aT1)>(T1off+T2off))) {
				hT2a = [aT2+T2off, gB[0]+TRcor];
				hT2c = [aT2-T2off, gB[0]-TRcor];
			}
			else {
				hT2a = [aT2+T2off, gB[0]];
				hT2c = [aT2, gB[0]];
			}
			newPath.push([hT2a, aT2b, hT2c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aT2b);
		}
		else if (topRBtn == 2) {
			hT2a = [aT2, gB[0]+T2off];
			hT2c = [aT2, gB[0]];
			newPath.push([hT2a, aT2b, hT2c]);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// le point d'ancrage  droite en haut /////////////
function anchorRight1() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber && ((aR2-aR1)>(R1off+R2off))) {
				hR1a = [gB[3]+TRcor, aR1+R1off];
				hR1c = [gB[3]-TRcor, aR1-R1off];
			}
			else {
				hR1a = [gB[3], aR1];
				hR1c = [gB[3], aR1-R1off];
			}
			newPath.push([hR1a, aR1b, hR1c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aR1b);
		}
		else if (topRBtn == 2) {
			hR1a = [gB[3], aR1];
			hR1c = [gB[3]-R1off, aR1];
			newPath.push([hR1a, aR1b, hR1c]);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// le point d'ancrage  droite en bas /////////////
function anchorRight2() {
	if (botR != 0) {
		if (botRBtn == 2) {
			if (camber && ((aR2-aR1)>(R1off+R2off))) {
				hR2a = [gB[3]-BRcor, aR2+R2off];
				hR2c = [gB[3]+BRcor, aR2-R2off];
			}
			else {
				hR2a = [gB[3], aR2+R2off];
				hR2c = [gB[3], aR2];
			}
			newPath.push([hR2a, aR2b, hR2c]);
		}
		else if (botRBtn == 0) {
			hR2a = [gB[3]-R2off, aR2];
			hR2c = [gB[3], aR2];
			newPath.push([hR2a, aR2b, hR2c]);
		}
		else if (botRBtn == 1) {
			newPath.push(aR2b);
		}
	}
	else {
		newPath.push([gB[3], gB[2]]);
	}
}

// le point d'ancrage en bas  droite /////////////
function anchorBottom2() {
	if (botR != 0) {
		if (botRBtn == 2) {
			if (camber && ((aB2-aB1)>(B1off+B2off))) {
				hB2a = [aB2-B2off, gB[2]+BRcor];
				hB2c = [aB2+B2off, gB[2]-BRcor];
			}
			else {
				hB2a = [aB2, gB[2]];
				hB2c = [aB2+B2off, gB[2]];
			}
			newPath.push([hB2a, aB2b, hB2c]);
		}
		else if (botRBtn == 0) {
			hB2a = [aB2, gB[2]];
			hB2c = [aB2, gB[2]-B2off];
			newPath.push([hB2a, aB2b, hB2c]);
		}
		else if (botRBtn == 1) {
			newPath.push(aB2b);
		}
	}
}

// le point d'ancrage en bas  gauche /////////////
function anchorBottom1() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber && ((aB2-aB1)>(B1off+B2off))) {
				hB1a = [aB1-B1off, gB[2]-BLcor];
				hB1c = [aB1+B1off, gB[2]+BLcor];
			}
			else {
				hB1a = [aB1-B1off, gB[2]];
				hB1c = [aB1, gB[2]];
			}
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 0) {
			hB1a = [aB1, gB[2]-B1off];
			hB1c = [aB1, gB[2]];
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aB1b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// le point d'ancrage  gauche en bas /////////////
function anchorLeft2() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber && ((aL2-aL1)>(L1off+L2off))) {
				hL2a = [gB[1]-TLcor, aL2-L2off];
				hL2c = [gB[1]+TLcor, aL2+L2off];
			}
			else {
				hL2a = [gB[1], aL2];
				hL2c = [gB[1], aL2+L2off];
			}
			newPath.push([hL2a, aL2b, hL2c]);
		}
		else if (botLBtn == 0) {
			hL2a = [gB[1], aL2];
			hL2c = [gB[1]+L2off, aL2];
			newPath.push([hL2a, aL2b, hL2c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aL2b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// le point d'ancrage  gauche en haut /////////////
function anchorLeft1() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber && ((aL2-aL1)>(L1off+L2off))) {
				hL1a = [gB[1]+TLcor, aL1-L1off];
				hL1c = [gB[1]-TLcor, aL1+L1off];
			}
			else {
				hL1a = [gB[1], aL1-L1off];
				hL1c = [gB[1], aL1];
			}
			newPath.push([hL1a, aL1b, hL1c]);
		}
		else if (topLBtn == 1) {
			newPath.push(aL1b);
		}
		else if (topLBtn == 2) {
			hL1a = [gB[1]+L1off, aL1];
			hL1c = [gB[1], aL1];
			newPath.push([hL1a, aL1b, hL1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// le coin  gauche en haut /////////////
function cornerTopLeft() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber) {
				if ((aT2-aT1)>(T1off+T2off)) {
					hT1a = [aT1+T1off, gB[0]-TLcor];
					hT1c = [aT1-T1off, gB[0]+TLcor];
				}
				else {
					hT1a = [aT1, gB[0]];
					hT1c = [aT1-T1off, gB[0]];
				}
				newPath.push([hT1a, aT1b, hT1c]);
				if ((aL2-aL1)>(L1off+L2off)) {
					hL1a = [gB[1]+TLcor, aL1-L1off];
					hL1c = [gB[1]-TLcor, aL1+L1off];
				}
				else {
					hL1a = [gB[1], aL1-L1off];
					hL1c = [gB[1], aL1];
				}
				newPath.push([hL1a, aL1b, hL1c]);
			}
			else {
				hT1a = [aT1, gB[0]];
				hT1c = [aT1-T1off, gB[0]];
				newPath.push([hT1a, aT1b, hT1c]);
				hL1a = [gB[1], aL1-L1off];
				hL1c = [gB[1], aL1];
				newPath.push([hL1a, aL1b, hL1c]);
			}
		}
		else if (topLBtn == 1) {
			newPath.push(aT1b);
			newPath.push(aL1b);
		}
		else if (topLBtn == 2) {
			hT1a = [aT1, gB[0]];
			hT1c = [aT1, gB[0]+T1off];
			newPath.push([hT1a, aT1b, hT1c]);
			hL1a = [gB[1]+L1off, aL1];
			hL1c = [gB[1], aL1];
			newPath.push([hL1a, aL1b, hL1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// le coin  droite en haut /////////////
function cornerTopRight() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber) {
				if ((aR2-aR1)>(R1off+R2off)) {
					hR1a = [gB[3]+TRcor, aR1+R1off];
					hR1c = [gB[3]-TRcor, aR1-R1off];
				}
				else {
					hR1a = [gB[3], aR1];
					hR1c = [gB[3], aR1-R1off];
				}
				newPath.push([hR1a, aR1b, hR1c]);
				if ((aT2-aT1)>(T1off+T2off)) {
					hT2a = [aT2+T2off, gB[0]+TRcor];
					hT2c = [aT2-T2off, gB[0]-TRcor];
				}
				else {
					hT2a = [aT2+T2off, gB[0]];
					hT2c = [aT2, gB[0]];
				}
				newPath.push([hT2a, aT2b, hT2c]);
			}
			else {
				hR1a = [gB[3], aR1];
				hR1c = [gB[3], aR1-R1off];
				newPath.push([hR1a, aR1b, hR1c]);
				hT2a = [aT2+T2off, gB[0]];
				hT2c = [aT2, gB[0]];
				newPath.push([hT2a, aT2b, hT2c]);
			}
		}
		else if (topRBtn == 2) {
			hR1a = [gB[3], aR1];
			hR1c = [gB[3]-R1off, aR1];
			newPath.push([hR1a, aR1b, hR1c]);
			hT2a = [aT2, gB[0]+T2off];
			hT2c = [aT2, gB[0]];
			newPath.push([hT2a, aT2b, hT2c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aR1b);
			newPath.push(aT2b);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// le coin  gauche en bas /////////////
function cornerBottomLeft() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber) {
				if ((aL2-aL1)>(L1off+L2off)) {
					hL2a = [gB[1]-BLcor, aL2-L2off];
					hL2c = [gB[1]+BLcor, aL2+L2off];
				}
				else {
					hL2a = [gB[1], aL2];
					hL2c = [gB[1], aL2+L2off];
				}				
				newPath.push([hL2a, aL2b, hL2c]);
				if ((aB2-aB1)>(B1off+B2off)) {
					hB1a = [aB1-B1off, gB[2]-BLcor];
					hB1c = [aB1+B1off, gB[2]+BLcor];
				}
				else {
					hB1a = [aB1-B1off, gB[2]];
					hB1c = [aB1, gB[2]];
				}
				newPath.push([hB1a, aB1b, hB1c]);				
			}
			else {
				hL2a = [gB[1], aL2];
				hL2c = [gB[1], aL2+L2off];
				newPath.push([hL2a, aL2b, hL2c]);
				hB1a = [aB1-B1off, gB[2]];
				hB1c = [aB1, gB[2]];
				newPath.push([hB1a, aB1b, hB1c]);
			}
		}
		else if (botLBtn == 0) {
			hL2a = [gB[1], aL2];
			hL2c = [gB[1]+L2off, aL2];
			newPath.push([hL2a, aL2b, hL2c]);
			hB1a = [aB1, gB[2]-B1off];
			hB1c = [aB1, gB[2]];
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aL2b);
			newPath.push(aB1b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// l'arrondi  droite /////////////
function roundedRight() {
	if (botRBtn == 2 && topRBtn == 0) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 2 && topRBtn == 1) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = aR1b;
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 2 && topRBtn == 2) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 1 && topRBtn == 0) {
		hR1a = aR1b;
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 1 && topRBtn == 1) {
		newPath.push(aR1b);
	}
	else if (botRBtn == 1 && topRBtn == 2) {
		hR1a = aR1b;
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 0) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 1) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = aR1b;
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 2) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
}

// l'arrondi en haut /////////////
function roundedTop() {
	if (topLBtn == 0 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = [aT1-T1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 0 && topRBtn == 1) {
		hT1a = aT1b;
		hT1c = [aT1-T1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 0 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+T2off];
		hT1c = [aT1-L1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 1 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = aT1b;
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 1 && topRBtn == 1) {
		newPath.push(aT1b);
	}
	else if (topLBtn == 1 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+T2off];
		hT1c = aT1b;
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = [aT1, gB[0]+T1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 1) {
		hT1a = aT1b;
		hT1c = [aT1, gB[0]+T1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+R1off];
		hT1c = [aT1, gB[0]+L1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
}

// l'arrondi  gauche /////////////
function roundedLeft() {
	if (topLBtn == 0 && botLBtn == 2) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 0 && botLBtn == 1) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = aL1b;
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 0 && botLBtn == 0) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = [gB[1]+L2off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 1 && botLBtn == 2) {
		hL1a = aL1b;
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 1 && botLBtn == 1) {
		newPath.push(aL1b);
	}
	else if (topLBtn == 1 && botLBtn == 0) {
		hL1a = aL1b;
		hL1c = [gB[1]+L1off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 2) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 1) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = aL1b;
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 0) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = [gB[1]+L2off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
}

// l'arrondi en bas /////////////
function roundedBottom() {
	if (botLBtn == 2 && botRBtn == 2) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 2 && botRBtn == 1) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = aB1b;
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 2 && botRBtn == 0) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 1 && botRBtn == 2) {
		hB1a = aB1b;
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 1 && botRBtn == 1) {
		newPath.push(aB1b);
	}
	else if (botLBtn == 1 && botRBtn == 0) {
		hB1a = aB1b;
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 2) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 1) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = aB1b;
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 0) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
}

// ---*---*---*---*---*---*---*---*---*---*---*---*
// rtablir les modifications (si ncessaire)
function resetRotation(curFrame) {
	// rtablir les angles de rotation et d'inclinaison
	if (rA != 0) {
		curFrame.rotationAngle = rA;
	}
	if (sA != 0) {
		curFrame.shearAngle = sA;
	}
}

function resetAsBefore() {
	// rtablir l'unit de mesure verticale
	if (vM != hM) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	// rtablir  l'unit inconnue
	if (curUnit == "inconnu") {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}